/* Aa array implementation of a queue. */

#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#define   EMPTY      0
#define   FULL       10000
#define   MAX_IND    (FULL - 1)

typedef   unsigned int         data;
typedef   enum {false, true}   boolean;

struct queue {
   int    cnt;                  /* a count of the elements */
   int    front;                /* index of the front element */
   int    rear;                 /* index of the rear element */
   data   *v;                   /* the array for the queue */
};

typedef   struct queue   queue;

void      initialize(queue *q);
void      enqueue(data d, queue *q);
data      dequeue(queue *q);
data      front(const queue *q);
boolean   empty(const queue *q);
boolean   full(const queue *q);
